set(CTEST_SITE "localhost")
set(CTEST_BUILD_NAME "branch_coverage_example")
set(CTEST_SOURCE_DIRECTORY ${CTEST_SCRIPT_DIRECTORY}/src)
set(CTEST_BINARY_DIRECTORY ${CTEST_SCRIPT_DIRECTORY}/bin)
set(CTEST_CMAKE_GENERATOR "Unix Makefiles")
set(CTEST_COVERAGE_COMMAND "gcov")

ctest_empty_binary_directory("${CTEST_BINARY_DIRECTORY}")
ctest_start(Experimental)

set(COVERAGE_OPTIONS
  "-DCMAKE_BUILD_TYPE=Debug"
  "-DCMAKE_CXX_FLAGS=-g -O0 --coverage"
  "-DCMAKE_C_FLAGS=-g -O0 --coverage"
  "-DCMAKE_EXE_LINKER_FLAGS=--coverage"
  "-DCMAKE_SHARED_LINKER_FLAGS=--coverage"
)
ctest_configure(OPTIONS "${COVERAGE_OPTIONS}")

ctest_build()
ctest_test()
ctest_submit()

# generate a GCOV tarball and upload it to CDash.
include(CTestCoverageCollectGCOV)
ctest_coverage_collect_gcov(
  TARBALL gcov.tar
  SOURCE ${CTEST_SOURCE_DIRECTORY}
  BUILD ${CTEST_BINARY_DIRECTORY}
  GCOV_COMMAND ${CTEST_COVERAGE_COMMAND}
)
if(EXISTS "${CTEST_BINARY_DIRECTORY}/gcov.tar")
  ctest_submit(CDASH_UPLOAD "${CTEST_BINARY_DIRECTORY}/gcov.tar"
    CDASH_UPLOAD_TYPE GcovTar)
endif()
